/*
**	$Id: DatePanel.c,v 1.5 92/05/01 12:52:09 olsen Sta Locker: olsen $
**	$Revision: 1.5 $
**	$Date: 92/05/01 12:52:09 $
**
**	Editing panel for date selection
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_MONTH,GAD_DAY,GAD_COMMENT,GAD_USE,GAD_CANCEL };

#define WIDTH	329
#define HEIGHT	75

STATIC UBYTE * __saveds
ShowMonth(struct Gadget *SomeGadget,WORD Level)
{
	return(LocaleString(Level + MSG_DATEPANEL_JANUARY_TXT));
}

STATIC struct Gadget *
CreateAllGadgets(struct TimeDate *TimeDate,struct Gadget **GadgetArray,struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		NewGadget . ng_LeftEdge		= 138;
		NewGadget . ng_TopEdge		= 12;
		NewGadget . ng_Width		= 181;
		NewGadget . ng_Height		= 14;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DATEPANEL_MONTH_GAD);
		NewGadget . ng_TextAttr		= &DefaultFont;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= PLACETEXT_LEFT|NG_HIGHLABEL;
		NewGadget . ng_VisualInfo	= VisualInfo;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			GT_Underscore,		'_',
			GTSL_Level,		TimeDate -> Month,
			GTSL_Max,		11,
			GTSL_MaxLevelLen,	9,
			GTSL_LevelFormat,	"%s",
			GTSL_DispFunc,		ShowMonth,
			PGA_Freedom,		LORIENT_HORIZ,
			GA_Immediate,		TRUE,
			GA_RelVerify,		TRUE,
		TAG_DONE);

		NewGadget . ng_TopEdge		= 27;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DATEPANEL_DAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			GT_Underscore,		'_',
			GTSL_Level,		TimeDate -> Day,
			GTSL_Min,		1,
			GTSL_Max,		31,
			GTSL_MaxLevelLen,	2,
			GTSL_LevelFormat,	"%2ld",
			PGA_Freedom,		LORIENT_HORIZ,
			GA_Immediate,		TRUE,
			GA_RelVerify,		TRUE,
		TAG_DONE);

		NewGadget . ng_TopEdge		= 42;
		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_COMMENT_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_MaxChars,	19,
			GTST_EditHook,	&CommandHook,
			GTST_String,	TimeDate -> Comment,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_LeftEdge		= 10;
		NewGadget . ng_TopEdge		= 60;
		NewGadget . ng_Width		= 88;	/* NEW 52 */
		NewGadget . ng_Height		= 12;
		NewGadget . ng_Flags		= 0;
		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= PLACETEXT_IN;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_LeftEdge		= WIDTH - 10 - NewGadget . ng_Width;
		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);
	}

	return(Gadget);
}

BYTE
DatePanel(struct TimeDate *TimeDate)
{
	STATIC BYTE MaxDays[12] = { 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

	struct Window	*PanelWindow;
	struct Gadget	*GadgetList;
	struct Gadget	*GadgetArray[GAD_CANCEL + 1];
	BYTE		 Result = FALSE;
	struct TimeDate	 LocalTimeDate;

	LocalTimeDate = *TimeDate;

	if(CreateAllGadgets(TimeDate,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	(Screen -> Width - WIDTH) >> 1,
			WA_Top,		(Screen -> Height - HEIGHT) >> 1,
			WA_Width,	WIDTH,
			WA_Height,	HEIGHT,
			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Screen,
			WA_IDCMP,	IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | IDCMP_GADGETDOWN | BUTTONIDCMP | SLIDERIDCMP,
			WA_Title,	LocaleString(MSG_DATEPANEL_DATE_SETTINGS_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 Class,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			while(!Terminated)
			{
				WaitPort(PanelWindow -> UserPort);

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					Class	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					if(Class == IDCMP_VANILLAKEY)
						KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&Class,&Code);

					if(Class == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(Class == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(Class == IDCMP_CLOSEWINDOW)
						Terminated = TRUE;

					if(Class == IDCMP_MOUSEMOVE)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_MONTH:	TimeDate -> Month = Code;
									break;

							case GAD_DAY:	TimeDate -> Day = Code;
									break;
						}
					}

					if(Class == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_MONTH:	TimeDate -> Month = Code;

									if(TimeDate -> Day > MaxDays[TimeDate -> Month])
									{
										GT_SetGadgetAttrs(GadgetArray[GAD_DAY],PanelWindow,NULL,
											GTSL_Level,	TimeDate -> Day = MaxDays[TimeDate -> Month],
										TAG_DONE);
									}

									break;

							case GAD_DAY:	if(Code > MaxDays[TimeDate -> Month])
									{
										Code = MaxDays[TimeDate -> Month];

										GT_SetGadgetAttrs(GadgetArray[GAD_DAY],PanelWindow,NULL,
											GTSL_Level,	Code,
										TAG_DONE);
									}

									TimeDate -> Day = Code;
									break;

							case GAD_USE:	strcpy(TimeDate -> Comment,GT_STRING(GadgetArray[GAD_COMMENT]));

									Terminated = TRUE;

									Result = TRUE;

									break;

							case GAD_CANCEL:*TimeDate = LocalTimeDate;

									Terminated = TRUE;

									break;

							default:	break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}

		FreeGadgets(GadgetList);
	}

	return(Result);
}
