/*
**	$Id: DayPanel.c,v 1.4 92/04/21 16:58:36 olsen Sta Locker: olsen $
**	$Revision: 1.4 $
**	$Date: 92/04/21 16:58:36 $
**
**	Editing panel for day of week selection
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_COMMENT=7,GAD_USE,GAD_CANCEL };

#define WIDTH	200
#define HEIGHT	159

STATIC struct Gadget *
CreateAllGadgets(struct TimeDate *TimeDate,struct Gadget **GadgetArray,struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		NewGadget . ng_LeftEdge		= 48;
		NewGadget . ng_TopEdge 		= 27;
		NewGadget . ng_Width		= 26;
		NewGadget . ng_Height		= 11;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DAYPANEL_MONDAY_GAD);
		NewGadget . ng_TextAttr		= &DefaultFont;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= PLACETEXT_RIGHT;
		NewGadget . ng_VisualInfo	= VisualInfo;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	TimeDate -> Day & DAY_MONDAY,
		TAG_DONE);

		NewGadget . ng_TopEdge		= 39;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DAYPANEL_TUESDAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	TimeDate -> Day & DAY_TUESDAY,
		TAG_DONE);

		NewGadget . ng_TopEdge		= 51;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DAYPANEL_WEDNESDAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	TimeDate -> Day & DAY_WEDNESDAY,
		TAG_DONE);

		NewGadget . ng_TopEdge		= 63;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DAYPANEL_THURSDAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	TimeDate -> Day & DAY_THURSDAY,
		TAG_DONE);

		NewGadget . ng_TopEdge		= 75;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DAYPANEL_FRIDAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	TimeDate -> Day & DAY_FRIDAY,
		TAG_DONE);

		NewGadget . ng_TopEdge		= 87;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DAYPANEL_SATURDAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	TimeDate -> Day & DAY_SATURDAY,
		TAG_DONE);

		NewGadget . ng_TopEdge		= 99;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DAYPANEL_SUNDAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	TimeDate -> Day & DAY_SUNDAY,
		TAG_DONE);

		NewGadget . ng_LeftEdge		= 10;
		NewGadget . ng_TopEdge		= 125;
		NewGadget . ng_Width		= 181;
		NewGadget . ng_Height		= 14;
		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_COMMENT_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= PLACETEXT_ABOVE|NG_HIGHLABEL;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTST_String,	TimeDate -> Comment,
			GTST_MaxChars,	19,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_LeftEdge		= 11;
		NewGadget . ng_TopEdge		= 143;
		NewGadget . ng_Width		= 88;	/* NEW 52 */
		NewGadget . ng_Height		= 12;
		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= PLACETEXT_IN;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_LeftEdge		= WIDTH - 10 - NewGadget . ng_Width;
		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_LeftEdge		= 56;
		NewGadget . ng_TopEdge		= 12;
		NewGadget . ng_GadgetText	= LocaleString(MSG_DAYPANEL_ACTIVE_DAYS_GAD);
		NewGadget . ng_Flags		= PLACETEXT_IN|NG_HIGHLABEL;
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(TEXT_KIND,Gadget,&NewGadget,
			TAG_DONE);
	}

	return(Gadget);
}

BYTE
DayPanel(struct TimeDate *TimeDate)
{
	struct Window	*PanelWindow;
	struct Gadget	*GadgetList;
	struct Gadget	*GadgetArray[GAD_CANCEL + 2];
	BYTE		 Result = FALSE;
	struct TimeDate	 LocalTimeDate;

	LocalTimeDate = *TimeDate;

	if(CreateAllGadgets(TimeDate,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	(Screen -> Width - WIDTH) >> 1,
			WA_Top,		(Screen -> Height - HEIGHT) >> 1,
			WA_Width,	WIDTH,
			WA_Height,	HEIGHT,
			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Screen,
			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | BUTTONIDCMP | STRINGIDCMP | CHECKBOXIDCMP,
			WA_Title,	LocaleString(MSG_DAYPANEL_DAY_SETTINGS_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 Class,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;
			LONG			 i;

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			while(!Terminated)
			{
				WaitPort(PanelWindow -> UserPort);

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					Class	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					if(Class == IDCMP_VANILLAKEY)
						KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&Class,&Code);

					if(Class == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(Class == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(Class == IDCMP_CLOSEWINDOW)
						Terminated = TRUE;

					if(Class == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_USE:	strcpy(TimeDate -> Comment,GT_STRING(GadgetArray[GAD_COMMENT]));

									TimeDate -> Day = 0;

									for(i = 0 ; i < 7 ; i++)
									{
										if(GT_CHECKED(GadgetArray[i]))
											TimeDate -> Day |= (1 << i);
									}

									Terminated = TRUE;

									Result = TimeDate -> Day;

									break;

							case GAD_CANCEL:*TimeDate = LocalTimeDate;

									Terminated = TRUE;

									break;

							default:	break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}

		FreeGadgets(GadgetList);
	}

	return(Result);
}
